SystemOrganization addCategory: #AttractorModelisation!

DynamicComposableModel subclass: #UISecondVersion
	instanceVariableNames: 'mainView xtview ytview ztview plus slider varValues minus attr precisionStep secondaryViews odesInputX odesInputY odesInputZ rec odesValues sizeOfUI sliderSigma sliderRho sliderBeta sliderX sliderY sliderZ recView v tau sliderTau reconstructionWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!UISecondVersion commentStamp: 'antoineZim 3/24/2017 19:01' prior: 0!
I am the new version

Try in playground:
|ui|
ui := UISecondVersion new.
ui refresh.
ui openView!

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/29/2017 14:30'!
initialize
	self initialize: AttractorDynOdes new! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 4/13/2017 15:45'!
initialize: attrIn
	"tau := 15."
	attr := attrIn.
	"rec := Reconstructor new.
		rec tau: tau.
		rec values: attr rk4.
		rec rebuild.
	v :=ViewMaker2Dfrom3D new .
		v values: rec xShifts ."	
	super initialize.
	self initializeWidgets.
	self extent: 1400 @ 750.
			! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 4/13/2017 15:47'!
initializeWidgets

	self instantiateModels: #(
		mainView RoassalModel

		xtview RoassalModel
		ytview RoassalModel
		ztview RoassalModel
		plus ButtonModel 
		sliderSigma SliderModel
		sliderRho SliderModel
		sliderBeta SliderModel
		sliderX SliderModel
		sliderY SliderModel
		sliderZ SliderModel
		varValues LabelModel
		minus ButtonModel
		precisionStep TextInputFieldModel
		odesValue LabelModel
		odesInputX TextInputFieldModel
		odesInputY TextInputFieldModel
		odesInputZ TextInputFieldModel
		sizeOfUI LabelModel
		).
	layout := (SpecLayout composed
	newRow:[ :firstCol|
		firstCol 
		newColumn: [ :bCol | bCol 
				newRow: [ :r| r 
					newColumn:[:r1 | r1 
						add: #odesInputX ; 
						add: #odesInputY; 
						add: #odesInputZ]] height: 150;
				newRow: [:r1 | r1  
					add: #odesValues ]height: 25 ] width:250;
		newColumn: [ :col |
			col
				newRow: [:r | r add: #mainView; newColumn: [:c | c 
						add: #sliderSigma; 
						add: #sliderRho; 
						add: #sliderBeta;
						add: #sliderX ;
						add: #sliderY ; 
						add: #sliderZ]];
			
				newRow:[:c | c 	add: #xtview; addSplitter;
									add: #ytview; addSplitter;
									add: #ztview];
				addSplitter;
				newRow: [:c| c add: #reconstructionWidget];
				newRow: [:c | c add: #sizeOfUI; add: #varValues] height:25 ;
				newColumn: [:aCol| aCol
					newRow: [ :aRow | aRow  
					add: #minus ;
					add: #precisionStep ] "height: 25" ]]
			
		];
	yourself).

	reconstructionWidget := ReconstructionWidget new.

	"Odes"
	odesInputX := TextInputFieldModel new.
	odesInputX beForCode.
	self odesInputX entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:x :y :z :sigma :rho :beta | your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0) ')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)  ') isNumber ifTrue: [ attr odesX:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,']')]. self refresh ]].
		
	odesInputY := TextInputFieldModel new.
	odesInputY beForCode.
	odesInputY entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:x :y :z :sigma :rho :beta | your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0) ')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)  ') isNumber ifTrue: [ attr odesY:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,']')]. self refresh ]].
	
	odesInputZ := TextInputFieldModel new.
	odesInputZ beForCode.
	odesInputZ entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Odes [:x :y :z :sigma :rho :beta | your odes)';		
		whenTextChanged: [:text| | currentBlock isCompilable| 
			isCompilable := true.
			currentBlock := [(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0) ')] on: MessageNotUnderstood do: [isCompilable := false] . 
			 isCompilable ifTrue: [ (Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,'] valueWithArguments: (Array with:10.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)  ') isNumber ifTrue: [ attr odesZ:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text,']')]. self refresh ]].
	
	odesValues := LabelModel new.
	self odesValues label:'odes= ',((attr odes) asString) .
	"Views"
	

	mainView := RoassalModel new.
	xtview := RoassalModel new.
	ytview := RoassalModel new.
	ztview := RoassalModel new.
		"recView := RoassalModel new."	
	"self recView script: [ :view :canvas |
		view addFromView: (v view).
		canvas camera focusOnCenter.
	]."
	"recView  := (v view canvas buildMorph) asSpecAdapter ."
	self mainView script: [ :view :canvas |
		view addFromView: (attr viewMaker view).
		canvas camera focusOnCenter.
	].
	self xtview script: [ :view :canvas |
		view addFromView: (attr viewMaker viewX) .
		canvas camera focusOnCenter.
	].
	self ytview script: [ :view :canvas |
		view addFromView: (attr viewMaker viewY).
		canvas camera focusOnCenter.
	].
	self ztview script: [ :view :canvas |
		view addFromView: (attr viewMaker viewZ).
		canvas camera focusOnCenter.
	].

	"Sliders"
	"sliderTau := SliderModel new."
	sliderSigma :=  SliderModel new.
	sliderRho :=  SliderModel new.
	sliderBeta :=  SliderModel new.
	sliderX :=  SliderModel new.
	sliderY :=  SliderModel new.
	sliderZ :=  SliderModel new.
	"sliderTau min:0;max:50;label:'0<=tau<=50'."
	sliderSigma "value: attr sigma;"min:0;max:20;label:'0<=sigma<=20'.
	sliderRho "value: attr rho ;"min:0;max:10;label:'0<=rho<=10';quantum: 0.2.
	sliderBeta "value: attr beta ;"min:0;max:40.0;label:'0<=beta<=40'.
	sliderX "value: (attr initialState at:1);" min:0;max:20;label:'0<=x<=10'.
	sliderY "value: (attr initialState at:2);" min:0;max:20;label:'0<=y<=10'.
	sliderZ "value: (attr initialState at:3);" min:0;max:20;label:'0<=z<=10'.
	
	"self sliderTau whenValueChangedDo: [:value |rec tau: value. self refresh]."
	
	self sliderSigma whenValueChangedDo: [:value |attr sigma: value. self refresh].
	self sliderRho whenValueChangedDo: [:value |attr rho: value. self refresh].
	self sliderBeta whenValueChangedDo: [:value |attr beta: value. self refresh].

	self sliderX whenValueChangedDo: [:value | attr stateX: value. self refresh].
	self sliderY whenValueChangedDo: [:value | attr stateY: value. self refresh].
	self sliderZ whenValueChangedDo: [:value | attr stateZ: value. self refresh].
					
	"feedback values"
	varValues := LabelModel new.
	self varValues label:'sigma=',(attr parameters at:1) asString ",'   r=',(attr r asString),'   precision=',(attr precision asString),'\n'",'   p =',(attr parameters at:2 )asString ,'   beta =',(attr parameters at:3) asString  .
	
	"Modifiers"
	precisionStep := TextInputFieldModel new.
	self precisionStep entryCompletion: nil;
		acceptOnCR: true;
		ghostText: 'Precision (Integer)';
		whenTextChanged: [:text| (text asInteger) isNil not ifTrue: [attr precision: (text asInteger)]. self refresh ].
	self minus label: 'zoom--'; state: false; 
			action: [attr view canvas camera scale: attr view canvas camera scale - 20.
	    attr view signalUpdate. self refresh].
	self plus label: 'r++'; state: false; 
			action: [attr r: attr r +1.  self refresh ].

	
	
	"Testers"
	sizeOfUI := LabelModel new.
	self sizeOfUI label:'UIsize= ',((self sizeInMemory ) asString) .! !

!UISecondVersion methodsFor: 'accessing' stamp: 'antoineZim 2/23/2017 16:34'!
layout
	^layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/28/2017 11:44'!
mainView
	^mainView! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:13'!
odesInputX
	^odesInputX! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:13'!
odesInputY
	^odesInputY! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 17:13'!
odesInputZ
	^odesInputZ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 14:42'!
odesValues
	^odesValues! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 2/23/2017 16:40'!
openView
	
	self openWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 20:43'!
precisionStep
	^precisionStep! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/24/2017 18:54'!
recView
	^recView ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 4/11/2017 13:05'!
reconstructionWidget
	^reconstructionWidget! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 4/13/2017 15:48'!
refresh
"TODO: find another solution to remake the model attr"
"attr refresh -> not working"
"attr view refresh -> not working"
	attr rebuild .
	"rec values: attr rk4.
	rec rebuild.
	v values: rec xShifts ."
	self varValues label:'sigma=',(attr sigma asString) ,'   rho =',(attr rho asString ),'   beta =',(attr beta asString ) ",'   r=',(attr r asString),'   precision=',(attr precision asString),'\n'".
	self odesValues label: 'odes= ',((attr odes) asString).
	self sizeOfUI label: 'sizeUI',((self sizeInMemory ) asString).
	self needRebuild: false.
	self buildWithSpecLayout: layout! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:10'!
sizeOfUI
	^sizeOfUI ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderBeta
	^sliderBeta ! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderRho
	^sliderRho! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderSigma
	^sliderSigma! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 4/6/2017 18:59'!
sliderTau
	^sliderTau! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderX
	^sliderX! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:23'!
sliderY
	^sliderY! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 3/17/2017 17:24'!
sliderZ
	^sliderZ! !

!UISecondVersion methodsFor: 'use' stamp: 'antoineZim 2/27/2017 16:37'!
varValues
	^varValues! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:39'!
xtview
	^xtview! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:39'!
ytview
	^ytview! !

!UISecondVersion methodsFor: 'initialization' stamp: 'antoineZim 2/27/2017 16:38'!
ztview
	^ztview! !

Object subclass: #Attractor
	instanceVariableNames: 'sigma rho beta dt values b attrView xValues yValues zValues graphList viewList ds precision xSteppedValues ySteppedValues zSteppedValues state initialState'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Attractor commentStamp: 'antoineZim 3/25/2017 16:28' prior: 0!
I am an empirical model of the Lorenz Attractor.

|a|
a := Attractor new.
a rebuild.
a!

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
beta
	^beta! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
beta: val
	beta := val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:37'!
buildAllViews 
	^(self buildAllViews: graphList)! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:37'!
buildAllViews: graphCollection
	|newViewList|
	newViewList := OrderedCollection new.
	graphCollection do: [ :eachB | newViewList add: (self buildView: eachB) ].
	^newViewList! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher

	b := RTGrapher new.
	ds := RTData new.
	ds dotShape ellipse size: 1; color: (Color blue).
	ds points: values.
	ds x: [:val | val at: 1]; y: [:val| val at: 2].
	b add: ds.
	b build.
	^b! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher: valueList
	|ab ads|
	ab := RTGrapher new.
	graphList add: ab.
	ads := RTData new.
	ads dotShape ellipse size: 1.
	ads points: valueList .
	ads connectColor: Color red.
	"ads y: #yourself."
	ab add: ads.
	ab build.
	! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:20'!
buildRTGrapher: anOrderedCollection withColor: color
	|ab ads|
	ab := RTGrapher new.
	ads := RTData new.
	ads dotShape ellipse size: 1; color: (Color blue).
	ads points: anOrderedCollection.
	ads connectColor: Color color.
	ads y: #yourself.
	ab add: ads.
	ab shouldUseNiceLabels: true.
	
	ab build.
	graphList add: ab! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/25/2017 16:33'!
buildValues
	| system stepper solver tempState |

	
	graphList :=OrderedCollection new.
	viewList :=OrderedCollection new.

	
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	state := initialState .
	system := ExplicitSystem
		block:[:val :t | |dx dy dz x y z|
			x := val at: 1. y := val at: 2. z := val at: 3.
			
			dx := sigma * (y - x).
			dy := beta * x - y - (x * z).
			dz := (-1 * rho * z + (x * y)).
			{dx. dy. dz}.
			].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	tempState := state .
	values := (0.0 to: 100.0 by: dt) collect:[:t |
		tempState:= stepper doStep: tempState time:t stepSize: dt].
	values do: [ :val | 
						xValues add: (val at:1). 
						yValues add: (val at:2).
						zValues add: (val at:3)].
	xSteppedValues:= OrderedCollection new.
	ySteppedValues:= OrderedCollection new.
	zSteppedValues:= OrderedCollection new.
	xSteppedValues := xValues .
	ySteppedValues := yValues .
	zSteppedValues := zValues .
	"xSteppedValues addAllLast: xValues from: 1 to: xValues size  by: precision .
	ySteppedValues addAllLast: yValues from: 2 to: yValues size  by: precision .
	zSteppedValues addAllLast: zValues from: 3 to: zValues size  by: precision ."! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 2/28/2017 23:27'!
buildView: ab
	|aView anElementsAndEdges |
	aView := RTView new.
	aView @ RTDraggableView.

	anElementsAndEdges := ab view elements, ab view edges.
	aView addAll: anElementsAndEdges.

	
	aView canvas camera noInitializationWhenOpen.
	aView canvas camera scale: 1.5.

	^aView! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:20'!
ds
	^ds! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
dt
	^dt! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
dt: val
	dt:= val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
elements
	^(b view elements)! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
graphList
	^graphList ! !

!Attractor methodsFor: 'initialization' stamp: 'antoineZim 3/24/2017 15:31'!
initialState
	^initialState ! !

!Attractor methodsFor: 'initialization' stamp: 'antoineZim 3/25/2017 16:29'!
initialize
	
	sigma := 10.0.
	beta := 30.0.
	rho := 8.0/3.0.
	dt := 0.1.
	precision := 25.
	initialState := #(10.0 10.0 10.0).
	self rebuild! !

!Attractor methodsFor: 'hooks' stamp: 'antoineZim 2/28/2017 23:21'!
openRTGrapher
	b open! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
precision
	^precision! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:21'!
precision: val
	precision := val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/25/2017 16:29'!
rebuild
	self buildValues .
	"self halt."
	self buildRTGrapher: xSteppedValues .
	self buildRTGrapher: ySteppedValues .
	self buildRTGrapher: zSteppedValues .
	graphList add: (self buildRTGrapher).
	viewList := self buildAllViews! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
rho
	^rho! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/25/2017 16:25'!
rho: val
	rho := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
sigma
	^sigma! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
sigma: val
	sigma := val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/24/2017 14:21'!
state
	^state! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/24/2017 14:28'!
stateX: val
	state at:1 put: val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/24/2017 14:28'!
stateY: val
	state at:2 put: val! !

!Attractor methodsFor: 'builders' stamp: 'antoineZim 3/24/2017 14:28'!
stateZ: val
	state at:3 put: val! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/24/2017 19:31'!
values
	^values! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
values: val
	values := val
! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
viewForGraphAt: indexInGraphList
	^((graphList at: indexInGraphList ) view)! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 2/28/2017 23:22'!
viewList
	^viewList 
	! !

!Attractor methodsFor: 'accessing' stamp: 'antoineZim 3/24/2017 17:48'!
xValues
	^xValues! !

Object subclass: #AttractorDynOdes
	instanceVariableNames: 'odes state data_length parameters initState sigma rho beta viewMaker'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!AttractorDynOdes commentStamp: 'antoineZim 3/28/2017 20:53' prior: 0!
Make the reconstruction 
parameters := #(sigma,rho beta)
state := #(x y z)
odes := [:xyz  :sigmaRhoBeta | odesFunctions  ]

Try in playground: 
| attrDynOdes |
attrDynOdes := AttractorDynOdes new .
attrDynOdes rebuild .
attrDynOdes rk4 !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:58'!
beta
	^beta! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:57'!
beta: val
	beta := val.
	parameters at: 3 put: val
	! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:45'!
initialize
	odes := self lorenz_odes.
	sigma := 10.0.
	rho := 8/3.0.
	beta := 28.0.
	viewMaker := ViewMaker2Dfrom3D new.
	initState := (Array with: -8.5 with: 8.0 with: 27.0 ).
	parameters :=(Array with: sigma with: rho with: beta).
	data_length := 1000.
	self rebuild! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:54'!
lorenz_generate
	odes := self lorenz_odes .
	^(self rebuild)! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 18:25'!
lorenz_odes
	^(Array 	with: [:x :y :z :sigma :rho :beta | sigma * (y - x)  ] 
				with:[:x :y :z :sigma :rho :beta | beta * x - y - (x * z)] 
				with: [:x :y :z :sigma :rho :beta | (-1 * rho * z + (x * y))]).

! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 18:29'!
makeCompareGraphs
	| g g1 g2 g3 ds1 ds2 ds3 rec x y z |
rec := (AttractorDynOdes new) lorenz_generate.

x := (rec collect: [ : each| each at: 1 ]).
y := (rec collect: [ : each| each at: 2 ]).
z := (rec collect: [ : each| each at: 3 ]).

g := RTMultiGrapher new.

g1 := RTGrapher new.
ds1 := RTData new.
ds1 label: 'x values'.
ds1 connectColor: Color red.
ds1 points: x.
ds1 interaction highlightDataset: Color black.
g1 add: ds1.
g2 := RTGrapher new.
ds2 := RTData new.
ds2 label: 'y values'.
ds2 connectColor: Color blue.
ds2 points: y.
ds2 interaction highlightDataset: Color purple.
g2 add: ds2.

g3 := RTGrapher new.
ds3 := RTData new.
ds3 label: 'z values'.
ds3 connectColor: Color green.
ds3 points: z.
ds3 interaction highlightDataset: Color black.
g3 add: ds3.

g1 axisY
	title: 'y 1';
	color: Color red.
g2 axisY
	title: 'y 2';
	color: Color blue.
g3 	axisY
	title: 'y 3';
	color: Color green.
g add: g1.
g add: g2.
g add: g3.
g legend.
^ g! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/17/2017 14:18'!
odes
	^odes ! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:06'!
odesX: val
	odes at:1 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:06'!
odesY: val
	odes at:2 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 17:06'!
odesZ: val
	odes at:3 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 16:05'!
parameters
	^parameters ! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:54'!
parameters: val
	parameters :=val.
	sigma := parameters at:1.
	beta := parameters at: 2.
	rho := parameters at: 3! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:43'!
rebuild
	|data tempState|
	tempState := state.
	data := self rk4.
	viewMaker values: data.	
	^data  
	
! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:58'!
rho
	^rho! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:58'!
rho: val
	rho := val.
	parameters at: 2 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/13/2017 16:01'!
rk4
	| system stepper solver s p r dt values tempState |
	s := parameters at:1 .
	p := parameters at:2.
	r := parameters at:3.
	dt := 0.1.
	state := initState.
	system := ExplicitSystem
		block:[:xyz :t | |dx dy dz x y z|
			x := xyz at: 1. y := xyz at: 2. z := xyz at: 3.
			dx := (odes at:1) valueWithArguments: (Array with:x with:y with:z with:s with:p with:r).
			dy := (odes at:2) valueWithArguments: (Array with:x with:y with:z with:s with:p with:r).
			dz := (odes at:3) valueWithArguments: (Array with:x with:y with:z with:s with:p with:r).
			{dx. dy. dz}.
			].
	stepper := RungeKuttaStepper onSystem: system.
	solver := (ExplicitSolver new) stepper: stepper; system: system; dt: dt.
	tempState := state .
	values := (80.0 to: 100.0 by: dt) collect:[:t |
		tempState:= stepper doStep: tempState time:t stepSize: dt].
	^values! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:58'!
sigma
	^sigma! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:57'!
sigma: val
	sigma := val.
	parameters at: 1 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/6/2017 18:52'!
stateX: val 
	state at: 1 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/6/2017 18:52'!
stateY: val 
	state at: 2 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/6/2017 18:52'!
stateZ: val 
	state at: 3 put: val! !

!AttractorDynOdes methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:43'!
viewMaker
	^viewMaker ! !

Object subclass: #Reconstructor
	instanceVariableNames: 'data_length values xValues yValues zValues xShifts yShifts zShifts tau'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!Reconstructor commentStamp: 'antoineZim 3/29/2017 14:18' prior: 0!
rec := Reconstructor new.
attrDynOdes := AttractorDynOdes new .
attrDynOdes rebuild .
rec values: attrDynOdes rk4.
rec rebuild.
v :=ViewMaker2Dfrom3D new .
v values: rec xShifts .
v rebuild .
v view.!

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 21:50'!
buildXShiftedSeries
	| tempShifts |
	xShifts := OrderedCollection new.
	tempShifts := OrderedCollection new.
	tempShifts add: xValues.
	tempShifts add: (self roll: xValues shift: tau).
	tempShifts add: (self roll: xValues shift: tau*2).
	1 to: xValues size do: [ :i| 
		xShifts add: (Array 
			with: ((tempShifts at:1) at:i) 
			with: ((tempShifts at:2) at:i) 
			with: ((tempShifts at:3) at:i)) ].
	^xShifts! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 21:48'!
buildYShiftedSeries
	| tempShifts |
	yShifts := OrderedCollection new.
	tempShifts := OrderedCollection new.
	tempShifts add: yValues.
	tempShifts add: (self roll: yValues shift: tau).
	tempShifts add: (self roll: yValues shift: tau*2).
	1 to: yValues size do: [ :i| 
		yShifts add: (Array 
			with: ((tempShifts at:1) at:i) 
			with: ((tempShifts at:2) at:i) 
			with: ((tempShifts at:3) at:i)) ].
	^yShifts! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 21:50'!
buildZShiftedSeries
	| tempShifts |
	zShifts := OrderedCollection new.
	tempShifts := OrderedCollection new.
	tempShifts add: zValues.
	tempShifts add: (self roll: zValues shift: tau).
	tempShifts add: (self roll: zValues shift: tau*2).
	1 to: zValues size do: [ :i| 
		zShifts add: (Array 
			with: ((tempShifts at:1) at:i) 
			with: ((tempShifts at:2) at:i) 
			with: ((tempShifts at:3) at:i)) ].
	^zShifts! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 21:28'!
initialize
	tau := 15! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 21:08'!
rebuild
	xShifts := OrderedCollection new.
	yShifts := OrderedCollection new.
	zShifts := OrderedCollection new.
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	values do: [ :xyz| 
		xValues add: (xyz at:1).
		yValues add: (xyz at:2).
		zValues add: (xyz at:3) ].
	self buildXShiftedSeries .
	self buildYShiftedSeries .
	self buildZShiftedSeries ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/13/2017 16:40'!
roll: aCollection shift: value
	| newCollection val|
	val := value % (aCollection size).
	newCollection := OrderedCollection new.
	val>0 ifTrue:[
	1 to: (aCollection size) -val do: [:i| 
		 newCollection addLast: (aCollection at: i) ].
	aCollection size to: aCollection size - val+1 by:-1 do:[:i|
		newCollection addFirst: (aCollection at: i)]].
	val<=0 ifTrue:[
	aCollection size to:(val abs)+1 by:-1 do:[:i|
		newCollection addFirst: (aCollection at: i)].
	1 to: val abs  do: [:i| 
		 newCollection addLast:  (aCollection at: i) ].
	].
	^newCollection 
	! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:10'!
tau
	^tau! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 21:02'!
tau: val
	tau := val! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 20:57'!
values: val
	values := val! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 20:58'!
xShifts
	^xShifts ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 20:58'!
yShifts
	^yShifts ! !

!Reconstructor methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/28/2017 20:58'!
zShifts
	^zShifts ! !

Object subclass: #ViewMaker2Dfrom3D
	instanceVariableNames: 'values view graph dataset seriesGraphs'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!ViewMaker2Dfrom3D commentStamp: 'antoineZim 3/29/2017 14:41' prior: 0!
Try in playground:
|v|
v :=ViewMaker2Dfrom3D new .
v values: AttractorDynOdes  new rk4.
v view!

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/13/2017 15:52'!
buildGraph
	graph := RTGrapher new.
	dataset := RTData new.
	dataset dotShape ellipse size: 1; color: (Color blue).
	dataset points: values.
	dataset x: [:val | val at: 1]; y: [:val| val at: 2].
	dataset connectColor: Color blue.
	graph add: dataset.
	graph build.
	RTCache new cacheView: graph view.
	^graph! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/13/2017 15:52'!
buildSeriesGraphs
	| xValues yValues zValues dsX dsY dsZ |
	xValues := OrderedCollection new.
	yValues := OrderedCollection new.
	zValues := OrderedCollection new.
	values do: [ :val | 
						xValues add: (val at:1). 
						yValues add: (val at:2).
						zValues add: (val at:3)].
	seriesGraphs := OrderedCollection new.
	seriesGraphs add: RTGrapher new.
	seriesGraphs add: RTGrapher new.
	seriesGraphs add: RTGrapher new.
	
	dsX := RTData new.
	dsX dotShape ellipse size: 1; color: (Color blue).
	dsX points: xValues.
	dsX connectColor: Color red.
	
	dsY := RTData new.
	dsY dotShape ellipse size: 1; color: (Color blue).
	dsY points: yValues.
	dsY connectColor: Color red.

	dsZ := RTData new.
	dsZ dotShape ellipse size: 1; color: (Color blue).
	dsZ points: zValues.
	dsZ connectColor: Color red.
	

	(seriesGraphs at:1) add: dsX.
	(seriesGraphs at:2) add: dsY.
	(seriesGraphs at:3) add: dsZ.
	
	
	
	seriesGraphs  do: [:g| g build.RTCache new cacheView: g view.].
	^seriesGraphs ! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 18:38'!
graph
	^graph! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/25/2017 16:41'!
rebuild
	self buildGraph.
	self buildSeriesGraphs ! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 19:29'!
values: val
	values:= val.
	self rebuild ! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/24/2017 19:28'!
view
	^(graph view)! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:49'!
viewX
	^((seriesGraphs at:1) view)! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:50'!
viewY
	^((seriesGraphs at:2) view)! !

!ViewMaker2Dfrom3D methodsFor: 'as yet unclassified' stamp: 'antoineZim 3/29/2017 14:50'!
viewZ
	^((seriesGraphs at:3) view)! !

ComposableModel subclass: #ReconstructionWidget
	instanceVariableNames: 'buttonX buttonY buttonZ container morphX morphY morphZ sliderTau viewMakerX viewMakerY viewMakerZ reconstructor currentViewMaker labelTau recView currentButton viewMakerList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!ReconstructionWidget class methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:12'!
defaultSpec
	<spec: #default>
	
	^ SpecLayout composed
		newColumn: [:r| r
			newRow: [ :row| row add: #recView ];
			newRow: [ :row| row add: #sliderTau ] height: 25;
			
			newRow: [ :row |
				row 
					add: #buttonX;
					add: #buttonY;
					add: #buttonZ;
					add: #labelTau ] height: 25
			
			]! !

!ReconstructionWidget class methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 13:02'!
example
	"self example"

	ReconstructionWidget  new openWithSpec.! !

!ReconstructionWidget class methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 13:02'!
title

	^ 'Reconstruction Widget'! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:36'!
buildViewMakers
	viewMakerX :=ViewMaker2Dfrom3D new .
		viewMakerX values: reconstructor xShifts .	
	viewMakerY :=ViewMaker2Dfrom3D new .
		viewMakerY values: reconstructor yShifts .	
	viewMakerZ :=ViewMaker2Dfrom3D new .
		viewMakerZ values: reconstructor zShifts .	
	viewMakerList := OrderedCollection new.
	viewMakerList add: viewMakerX ; add: viewMakerY ; add: viewMakerZ .! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 12:29'!
buttonX

	^ buttonX! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 12:29'!
buttonY

	^ buttonY! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 12:29'!
buttonZ

	^ buttonZ! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 15:53'!
initialize

	self initializeMorphs.
	super initialize.
	recView := RoassalModel new.
! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:35'!
initializeMorphs
	| attr|
	attr := AttractorDynOdes new.
	reconstructor := Reconstructor new.
		reconstructor values: attr rk4.
		reconstructor rebuild.
	currentViewMaker := 1.	
	self buildViewMakers.
! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 14:43'!
initializePresenter

	self on: buttonX show: viewMakerX.
	self on: buttonY show: viewMakerY.
	self on: buttonZ show: viewMakerZ.
	! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/13/2017 15:39'!
initializeWidgets

	buttonX := self newRadioButton.
	buttonY := self newRadioButton.
	buttonZ := self newRadioButton.
	labelTau := LabelModel new.
	sliderTau := SliderModel new.
	currentButton := buttonX .
	buttonX label: 'ButtonX'.
	buttonY label: 'ButtonY'.
	buttonZ label: 'ButtonZ'.
	sliderTau min:0;max:50;label:'0<=tau<=50'.
	
	self labelTau label:'tau= ',((reconstructor tau ) asString) .
	
	self sliderTau whenValueChangedDo: [:value |
		reconstructor tau: value. reconstructor rebuild. 
		self labelTau label:'tau= ',((reconstructor tau) asString). 	
		self buildViewMakers. 
		self refresh].	
	
	self setFocus.
	self setGroup.
	! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:10'!
labelTau
	^labelTau! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/13/2017 15:40'!
on: button show: aViewMaker

	button whenActivatedDo: [currentButton := button.
									((button label asString) = 'ButtonX') ifTrue: [currentViewMaker := 1] .
									((button label asString) = 'ButtonY') ifTrue: [currentViewMaker := 2] .
									((button label asString) = 'ButtonZ') ifTrue: [currentViewMaker := 3] .
									"currentViewMaker := viewMakerList indexOf: aViewMaker."  
									self refresh].
! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:23'!
recView
	^recView ! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 16:37'!
refresh

	self recView script: [ :view :canvas |
		view addFromView: (viewMakerList at: currentViewMaker)  view.
		canvas camera focusOnCenter.
	].! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 14:05'!
setFocus
	
	self focusOrder
		add: buttonX;
		add: buttonY;
		add: buttonZ. 
	! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 12:31'!
setGroup

	RadioButtonGroup new 
		addRadioButton: buttonX;
		addRadioButton: buttonY;
		addRadioButton: buttonZ;
		default: buttonX.
	! !

!ReconstructionWidget methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/11/2017 13:49'!
sliderTau
	^sliderTau! !

TestCase subclass: #AttractorDynOdesTest
	instanceVariableNames: 'attrDynOdes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'AttractorModelisation'!

!AttractorDynOdesTest methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/3/2017 12:17'!
setUp
	attrDynOdes := AttractorDynOdes new .
	attrDynOdes rebuild .! !

!AttractorDynOdesTest methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/3/2017 12:34'!
testBuildGraph
	|  text1 |
	text1 := 'x+2'.
	attrDynOdes odesX:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text1,']').
	attrDynOdes rebuild.

	
! !

!AttractorDynOdesTest methodsFor: 'as yet unclassified' stamp: 'antoineZim 4/3/2017 12:34'!
testChangeOdes
	|  text1 |
	text1 := 'x+2'.
	attrDynOdes odesX:(Compiler evaluate: '[:x :y :z :sigma :rho :beta |',text1,']').
	self assert: (attrDynOdes odes at:1) argumentCount  = 6.
	self assert: ((attrDynOdes odes at:1) valueWithArguments: (Array with:3.0 with:10.0 with:10.0 with:10.0 with:30.0 with:8.0/3.0)) = 5.

	
! !
